zoukankan      html  css  js  c++  java
  • HDU

    LOOPS

    Time Limit: 15000/5000 MS (Java/Others)    Memory Limit: 125536/65536 K (Java/Others)
    Total Submission(s): 6423    Accepted Submission(s): 2572


    Problem Description
    Akemi Homura is a Mahou Shoujo (Puella Magi/Magical Girl).

    Homura wants to help her friend Madoka save the world. But because of the plot of the Boss Incubator, she is trapped in a labyrinth called LOOPS.

    The planform of the LOOPS is a rectangle of R*C grids. There is a portal in each grid except the exit grid. It costs Homura 2 magic power to use a portal once. The portal in a grid G(r, c) will send Homura to the grid below G (grid(r+1, c)), the grid on the right of G (grid(r, c+1)), or even G itself at respective probability (How evil the Boss Incubator is)!
    At the beginning Homura is in the top left corner of the LOOPS ((1, 1)), and the exit of the labyrinth is in the bottom right corner ((R, C)). Given the probability of transmissions of each portal, your task is help poor Homura calculate the EXPECT magic power she need to escape from the LOOPS.




     
    Input
    The first line contains two integers R and C (2 <= R, C <= 1000).

    The following R lines, each contains C*3 real numbers, at 2 decimal places. Every three numbers make a group. The first, second and third number of the cth group of line r represent the probability of transportation to grid (r, c), grid (r, c+1), grid (r+1, c) of the portal in grid (r, c) respectively. Two groups of numbers are separated by 4 spaces.

    It is ensured that the sum of three numbers in each group is 1, and the second numbers of the rightmost groups are 0 (as there are no grids on the right of them) while the third numbers of the downmost groups are 0 (as there are no grids below them).

    You may ignore the last three numbers of the input data. They are printed just for looking neat.

    The answer is ensured no greater than 1000000.

    Terminal at EOF


     
    Output
    A real number at 3 decimal places (round to), representing the expect magic power Homura need to escape from the LOOPS.

     
    Sample Input
    2 2 0.00 0.50 0.50 0.50 0.00 0.50 0.50 0.50 0.00 1.00 0.00 0.00
     
    Sample Output
    6.000
     
    Source
     
    Recommend
    chenyongfu
     
     
    题解:刚开始左概率dp,就从这个最简单的概率dp开始吧。
    题目要求从左上角到右下角消耗的魔法的期望。如果要找一个位置的期望与它左边和上面的的期望的关系
    会比较困难,所以,就反着来找,找一个位置的期望与它右边和下面的的期望的关系,设dp[i][j]为(i,j)到(r,c)
    消耗魔法的期望:
    有dp[i][j]=p1*dp[i][j]+p2*dp[i][j+1]+p3*dp[i+1][j]+2,化简可得:
    dp[i][j]=(p2*dp[i][j+1]+p3*dp[i+1][j]+2)/(1-p1);
    如果p1=1则无法到达终点,题目说答案不小于1000000
    则除了最后一点,就没有p1=1的点;或者不能到p1=1的点
    #include<cstdio>
    #include<cstring>
    #include<cmath>
    const double eps=1e-7;
    
    struct node
    {
        double a,b,c;
    } w[1005][1005];
    
    double dp[1005][1005];
    
    int main()
    {
        int r,c;
        while(~scanf("%d%d",&r,&c))
        {
            for(int i=1; i<=r; i++)
                for(int j=1; j<=c; j++)
                    scanf("%lf%lf%lf",&w[i][j].a,&w[i][j].b,&w[i][j].c);
            dp[r][c]=0;
            for(int i=r; i>=1; i--)
                for(int j=c; j>=1; j--)
                    if(fabs(1-w[i][j].a)>eps)
                        dp[i][j]=(w[i][j].b*dp[i][j+1]+w[i][j].c*dp[i+1][j]+2)/(1-w[i][j].a);
            printf("%.3lf
    ",dp[1][1]);
        }
        return 0;
    }
    View Code
  • 相关阅读:
    006_linux驱动之_ioremap函数使用
    004_linux驱动之_class_create创建一个设备类
    003_linux驱动之_file_operations函数
    002_linux驱动之_register_chrdev注册字符设备
    001_linux驱动之_驱动的加载和卸载
    007_linuxC++之_构造函数的初级应用
    006_linuxC++之_引用
    005_linuxC++之_指针的引入
    004_linuxC++之_函数的重载
    003_linuxC++之_namespace使用
  • 原文地址:https://www.cnblogs.com/siyecaodesushuo/p/7158847.html
Copyright © 2011-2022 走看看